## libsdl2 2.30.0+dfsg

=== CMakeLists.txt ===
if(${CMAKE_CURRENT_SOURCE_DIR} STREQUAL ${CMAKE_CURRENT_BINARY_DIR})
  message(FATAL_ERROR "Prevented in-tree build. Please create a build directory outside of the SDL source code and run \"cmake -S ${CMAKE_SOURCE_DIR} -B .\" from there")
endif()

# MSVC runtime library flags are selected by an abstraction.
set(CMAKE_POLICY_DEFAULT_CMP0091 NEW)

cmake_minimum_required(VERSION 3.0.0...3.5)
project(SDL2 C CXX)

if(CMAKE_SOURCE_DIR STREQUAL PROJECT_SOURCE_DIR)
  set(SDL2_SUBPROJECT OFF)
else()
  set(SDL2_SUBPROJECT ON)
endif()

if (HAIKU)
  set(LINKER_LANGUAGE CXX)
endif()

set(EXTRA_LIBS)
set(EXTRA_LDFLAGS)

set(CMAKE_DEPENDS)
set(PKGCONFIG_DEPENDS)

# This is a virtual "library" that just exists to collect up compiler and
#  linker options that used to be global to this CMake project. When you
#  specify it as part of a real library's target_link_libraries(), that
#  library will also gain all those build options too. This is meant to
#  modularize old calls to the global add_definitions and include_directories,
#  etc. See https://github.com/libsdl-org/SDL/issues/4150
add_library(sdl-build-options INTERFACE)

if(WINDOWS_STORE)
  target_compile_definitions(sdl-build-options INTERFACE "-DSDL_BUILDING_WINRT=1")
  target_compile_options(sdl-build-options INTERFACE "-ZW")
endif()

# CMake 3.0 expands the "if(${A})" in "set(OFF 1);set(A OFF);if(${A})" to "if(1)"
# CMake 3.24+ emits a warning when not set.
unset(OFF)
unset(ON)
if(POLICY CMP0054)
  cmake_policy(SET CMP0054 NEW)
endif()

# !!! FIXME: this should probably do "MACOSX_RPATH ON" as a target property
# !!! FIXME:  for the SDL2 shared library (so you get an
# !!! FIXME:  install_name ("soname") of "@rpath/libSDL-whatever.dylib"
# !!! FIXME:  instead of "/usr/local/lib/libSDL-whatever.dylib"), but I'm
# !!! FIXME:  punting for now and leaving the existing behavior. Until this
# !!! FIXME:  properly resolved, this line silences a warning in CMake 3.0+.
# !!! FIXME:  remove it and this comment entirely once the problem is
# !!! FIXME:  properly resolved.
#cmake_policy(SET CMP0042 OLD)

include(CheckLibraryExists)
include(CheckIncludeFiles)
include(CheckIncludeFile)
include(CheckLanguage)
include(CheckSymbolExists)
include(CheckCSourceCompiles)
include(CheckCSourceRuns)
include(CheckCCompilerFlag)
include(CheckCXXCompilerFlag)
include(CheckStructHasMember)
include(CMakeDependentOption)
include(CMakePushCheckState)
include(GNUInstallDirs)

find_package(PkgConfig)

list(APPEND CMAKE_MODULE_PATH "${SDL2_SOURCE_DIR}/cmake")
include(${SDL2_SOURCE_DIR}/cmake/macros.cmake)
include(${SDL2_SOURCE_DIR}/cmake/sdlchecks.cmake)
include(${SDL2_SOURCE_DIR}/cmake/sdlplatform.cmake)
include(${SDL2_SOURCE_DIR}/cmake/CheckCPUArchitecture.cmake)

# Enable large file support on 32-bit glibc, so that we can access files
# with large inode numbers
check_symbol_exists("__GLIBC__" "stdlib.h" LIBC_IS_GLIBC)
if (LIBC_IS_GLIBC AND CMAKE_SIZEOF_VOID_P EQUAL 4)
    add_definitions(-D_FILE_OFFSET_BITS=64)
endif()

# See docs/release_checklist.md
set(SDL_MAJOR_VERSION 2)
set(SDL_MINOR_VERSION 30)
set(SDL_MICRO_VERSION 0)
set(SDL_VERSION "${SDL_MAJOR_VERSION}.${SDL_MINOR_VERSION}.${SDL_MICRO_VERSION}")

# Set defaults preventing destination file conflicts
set(SDL_CMAKE_DEBUG_POSTFIX "d"
    CACHE STRING "Name suffix for debug builds")

mark_as_advanced(CMAKE_IMPORT_LIBRARY_SUFFIX SDL_CMAKE_DEBUG_POSTFIX)

# Calculate a libtool-like version number
math(EXPR SDL_BINARY_AGE "${SDL_MINOR_VERSION} * 100 + ${SDL_MICRO_VERSION}")
if(SDL_MINOR_VERSION MATCHES "[02468]$")
    # Stable branch, 2.24.1 -> libSDL2-2.0.so.0.2400.1
    set(SDL_INTERFACE_AGE ${SDL_MICRO_VERSION})
else()
    # Development branch, 2.23.1 -> libSDL2-2.0.so.0.2301.0
    set(SDL_INTERFACE_AGE 0)
endif()

# Increment this if there is an incompatible change - but if that happens,
# we should rename the library from SDL2 to SDL3, at which point this would
# reset to 0 anyway.
set(LT_MAJOR "0")

math(EXPR LT_AGE "${SDL_BINARY_AGE} - ${SDL_INTERFACE_AGE}")
math(EXPR LT_CURRENT "${LT_MAJOR} + ${LT_AGE}")
set(LT_REVISION "${SDL_INTERFACE_AGE}")
# For historical reasons, the library name redundantly includes the major
# version twice: libSDL2-2.0.so.0.
# TODO: in SDL 3, set the OUTPUT_NAME to plain SDL3, which will simplify
# it to libSDL3.so.0
set(LT_RELEASE "2.0")
set(LT_VERSION "${LT_MAJOR}.${LT_AGE}.${LT_REVISION}")

# The following should match the versions in the Xcode project file.
# Each version is 1 higher than you might expect, for compatibility
# with libtool: macOS ABI versioning is 1-based, unlike other platforms
# which are normally 0-based.
math(EXPR DYLIB_CURRENT_VERSION_MAJOR "${LT_MAJOR} + ${LT_AGE} + 1")
math(EXPR DYLIB_CURRENT_VERSION_MINOR "${LT_REVISION}")
set(DYLIB_CURRENT_VERSION "${DYLIB_CURRENT_VERSION_MAJOR}.${DYLIB_CURRENT_VERSION_MINOR}.0")
set(DYLIB_COMPATIBILITY_VERSION "${DYLIB_CURRENT_VERSION_MAJOR}.0.0")

# This list holds all generated headers.
# To avoid generating them twice, these are added to a dummy target on which all sdl targets depend.
set(SDL_GENERATED_HEADERS)

#message(STATUS "${LT_VERSION} :: ${LT_AGE} :: ${LT_REVISION} :: ${LT_CURRENT} :: ${LT_RELEASE}")

check_cpu_architecture(x86 SDL_CPU_X86)
check_cpu_architecture(x64 SDL_CPU_X64)
check_cpu_architecture(arm32 SDL_CPU_ARM32)
check_cpu_architecture(arm64 SDL_CPU_ARM64)
check_cpu_architecture(loongarch64 SDL_CPU_LOONGARCH64)

# Check for 64 or 32 bit
set(SIZEOF_VOIDP ${CMAKE_SIZEOF_VOID_P})
if(CMAKE_SIZEOF_VOID_P EQUAL 8)
  set(ARCH_64 TRUE)
  set(PROCESSOR_ARCH "x64")
else()
  set(ARCH_64 FALSE)
  set(PROCESSOR_ARCH "x86")
endif()
set(LIBNAME SDL2)
if(NOT LIBTYPE)
  set(LIBTYPE SHARED)
endif()

# Get the platform
SDL_DetectCMakePlatform()

# Don't mistake osx for unix
if(UNIX AND NOT ANDROID AND NOT APPLE AND NOT RISCOS)
  set(UNIX_SYS ON)
else()
  set(UNIX_SYS OFF)
endif()

if(UNIX OR APPLE)
  set(UNIX_OR_MAC_SYS ON)
else()
  set(UNIX_OR_MAC_SYS OFF)
endif()

# Emscripten pthreads work, but you need to have a non-pthread fallback build
#  for systems without support. It's not currently enough to not use
#  pthread functions in a pthread-build; it won't start up on unsupported
#  browsers. As such, you have to explicitly enable it on Emscripten builds
#  for the time being. This default with change to ON once this becomes
#  commonly supported in browsers or the Emscripten teams makes a single
#  binary work everywhere.
if (UNIX_OR_MAC_SYS AND NOT EMSCRIPTEN)
  set(SDL_PTHREADS_ENABLED_BY_DEFAULT ON)
else()
  set(SDL_PTHREADS_ENABLED_BY_DEFAULT OFF)
endif()

if(UNIX_SYS OR ANDROID)
  set(SDL_CLOCK_GETTIME_ENABLED_BY_DEFAULT ON)
else()
  set(SDL_CLOCK_GETTIME_ENABLED_BY_DEFAULT OFF)
endif()

# The hidraw support doesn't catch Xbox, PS4 and Nintendo controllers,
#  so we'll just use libusb when it's available. libusb does not support iOS,
#  so we default to yes on iOS.
#  TODO: Windows can support libusb, the hid.c file just depends on Unix APIs
if((WINDOWS AND NOT WINDOWS_STORE) OR IOS OR TVOS OR ANDROID)
  set(HIDAPI_SKIP_LIBUSB TRUE)
else()
  set(HIDAPI_SKIP_LIBUSB FALSE)
endif()

# On the other hand, *BSD specifically uses libusb only, so we make a special
#  case just for them.
if(FREEBSD OR NETBSD OR OPENBSD OR BSDI)
  set(HIDAPI_ONLY_LIBUSB TRUE)
else()
  set(HIDAPI_ONLY_LIBUSB FALSE)
endif()

# Compiler info
if(CMAKE_C_COMPILER_ID MATCHES "Clang|IntelLLVM")
  set(USE_CLANG TRUE)
  set(OPT_DEF_ASM TRUE)
  # Visual Studio 2019 v16.2 added support for Clang/LLVM.
  # Check if a Visual Studio project is being generated with the Clang toolset.
  if(MSVC)
    set(MSVC_CLANG TRUE)
  endif()
elseif(CMAKE_COMPILER_IS_GNUCC)
  set(USE_GCC TRUE)
  set(OPT_DEF_ASM TRUE)
elseif(MSVC_VERSION GREATER 1400) # VisualStudio 8.0+
  set(OPT_DEF_ASM TRUE)
  #set(CMAKE_C_FLAGS "/ZI /WX- /
elseif(CMAKE_C_COMPILER_ID MATCHES "^Intel$")
  set(OPT_DEF_ASM TRUE)
  set(USE_INTELCC TRUE)
elseif(CMAKE_C_COMPILER_ID MATCHES "QCC")
  set(USE_QCC TRUE)
else()
  set(OPT_DEF_ASM FALSE)
endif()

if(USE_GCC OR USE_CLANG OR USE_INTELCC OR USE_QCC)
  set(OPT_DEF_GCC_ATOMICS ON)
endif()

# Default option knobs
if(UNIX OR MINGW OR MSYS OR (USE_CLANG AND NOT WINDOWS) OR VITA OR PSP OR PS2 OR N3DS)
  set(OPT_DEF_LIBC ON)
endif()
if(WINDOWS OR IOS OR TVOS)
  set(SDL_SYSTEM_ICONV_DEFAULT OFF)
else()
  set(SDL_SYSTEM_ICONV_DEFAULT ON)
endif()

if(NOT ("$ENV{CFLAGS}" STREQUAL ""))
  if(CMAKE_VERSION VERSION_LESS 3.11.0)
     message(WARNING "SDL's CMakeLists.txt no longer checks the CFLAGS environment.")
     message(WARNING "Please use CMake's CMAKE_C_FLAGS and CMAKE_BUILD_TYPE variables directly.")
     message(WARNING "Or upgrade to CMake >= 3.11.0, which respects the CFLAGS environment var.")
  endif()
endif()

# Build in parallel under Visual Studio. Not enabled by default.
if(MSVC AND NOT USE_CLANG)
  target_compile_options(sdl-build-options INTERFACE "/MP")
endif()

if(MSVC)
  option(SDL_FORCE_STATIC_VCRT "Force /MT for static VC runtimes" OFF)
  if(SDL_FORCE_STATIC_VCRT)
    if(NOT DEFINED CMAKE_MSVC_RUNTIME_LIBRARY)
      set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
    endif()
    foreach(flag_var
        CMAKE_C_FLAGS CMAKE_C_FLAGS_DEBUG CMAKE_C_FLAGS_RELEASE
        CMAKE_C_FLAGS_MINSIZEREL CMAKE_C_FLAGS_RELWITHDEBINFO)
      if(${flag_var} MATCHES "/MD")
        string(REGEX REPLACE "/MD" "/MT" ${flag_var} "${${flag_var}}")
      endif()
    endforeach()
  endif()

  if(NOT SDL_LIBC)
    # Make sure /RTC1 is disabled, otherwise it will use functions from the CRT
    foreach(flag_var
        CMAKE_C_FLAGS CMAKE_C_FLAGS_DEBUG CMAKE_C_FLAGS_RELEASE
        CMAKE_C_FLAGS_MINSIZEREL CMAKE_C_FLAGS_RELWITHDEBINFO)
      string(REGEX REPLACE "/RTC(su|[1su])" "" ${flag_var} "${${flag_var}}")
    endforeach(flag_var)
  endif()

  if(MSVC_CLANG)
    # clang-cl treats /W4 as '-Wall -Wextra' -- we don't need -Wextra
    foreach(flag_var
        CMAKE_C_FLAGS CMAKE_C_FLAGS_DEBUG CMAKE_C_FLAGS_RELEASE
        CMAKE_C_FLAGS_MINSIZEREL CMAKE_C_FLAGS_RELWITHDEBINFO)
      string(REGEX REPLACE "/W4" "/W3" ${flag_var} "${${flag_var}}")
    endforeach(flag_var)
  endif()
endif()

# Those are used for pkg-config and friends, so that the sdl2.pc, sdl2-config,
# etc. are created correctly.
set(SDL_LIBS "-lSDL2")
set(SDL_CFLAGS )

# When building shared lib for Windows with MinGW,
# avoid the DLL having a "lib" prefix
if(WINDOWS)
  set(CMAKE_SHARED_LIBRARY_PREFIX "")
endif()

set(CMAKE_REQUIRED_FLAGS "${CMAKE_REQUIRED_FLAGS} -D_GNU_SOURCE=1")

# Emscripten toolchain has a nonempty default value for this, and the checks
# in this file need to change that, so remember the original value, and
# restore back to that afterwards. For check_function_exists() to work in
# Emscripten, this value must be at its default value.
set(ORIG_CMAKE_REQUIRED_FLAGS ${CMAKE_REQUIRED_FLAGS})

if(CYGWIN)
  # We build SDL on cygwin without the UNIX emulation layer
  target_include_directories(sdl-build-options INTERFACE "/usr/include/mingw")
  set(CMAKE_REQUIRED_FLAGS "${CMAKE_REQUIRED_FLAGS} -mno-cygwin")
  check_c_source_compiles("int main(int argc, char **argv) { return 0; }"
    HAVE_GCC_NO_CYGWIN)
  set(CMAKE_REQUIRED_FLAGS ${ORIG_CMAKE_REQUIRED_FLAGS})
  if(HAVE_GCC_NO_CYGWIN)
    list(APPEND EXTRA_LDFLAGS_BUILD "-mno-cygwin")
    list(APPEND SDL_LIBS "-mno-cygwin")
  endif()
  list(APPEND SDL_CFLAGS "-I/usr/include/mingw")
endif()

# General includes
target_compile_definitions(sdl-build-options INTERFACE "-DUSING_GENERATED_CONFIG_H")
target_include_directories(sdl-build-options BEFORE INTERFACE "${SDL2_BINARY_DIR}/include" "${SDL2_BINARY_DIR}/include-config-$<LOWER_CASE:$<CONFIG>>")
# Note: The clang toolset for Visual Studio does not support the '-idirafter' option.
if(USE_GCC OR (USE_CLANG AND NOT MSVC_CLANG))
  # !!! FIXME: do we _need_ to mess with CMAKE_C_FLAGS here?
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -idirafter \"${SDL2_SOURCE_DIR}/src/video/khronos\"")
else()

=== debian/changelog ===
libsdl2 (2.30.0+dfsg-1ubuntu3.1) noble; urgency=medium

  * d/p/u/fix-order-n-squared-device-walking-issue.patch,
    d/p/u/avoid-opening-non-joystick-devices.patch,
    d/p/u/initialize-udev-before-joystick-scan.patch: Address a performance
    issue during joystick/gamepad detection, caused by device
    enumeration. Speed it up by using udev info instead of opening each
    device file.
    (LP: #2085140)

 -- Bryce Harrington <bryce@canonical.com>  Tue, 28 Jan 2025 22:24:18 -0800

libsdl2 (2.30.0+dfsg-1build3) noble; urgency=medium

  * No-change rebuild against libasound2t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 07 Apr 2024 07:16:43 +0000

libsdl2 (2.30.0+dfsg-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 02:16:05 +0000

libsdl2 (2.30.0+dfsg-1build1) noble; urgency=medium

  * No-change rebuild against libasound2t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 12 Mar 2024 06:38:12 +0000

libsdl2 (2.30.0+dfsg-1) unstable; urgency=medium

  * New upstream stable release
    - No functional changes since 2.29.3 in code that is used by Debian
  * d/libsdl2-2.0-0.symbols: Require stable versions for recent symbols
  * Release to unstable

 -- Simon McVittie <smcv@debian.org>  Fri, 02 Feb 2024 12:01:57 +0000

libsdl2 (2.29.3+dfsg-1) experimental; urgency=medium

  * New upstream development prerelease
  * d/patches: Drop most patches, included in the prerelease
  * d/copyright: Update

 -- Simon McVittie <smcv@debian.org>  Mon, 29 Jan 2024 14:22:23 +0000

libsdl2 (2.29.2+dfsg-1) experimental; urgency=medium

  * New upstream development prerelease
  * d/patches: Add post-prerelease fixes from the upstream release-2.30.x
    branch, up to commit prerelease-2.29.2-5-g52181848d, excluding an
    Android-specific change.
  * d/rules: Remove workarounds previously used to run testautomation.
    It's now run by the upstream build system.

 -- Simon McVittie <smcv@debian.org>  Tue, 23 Jan 2024 12:01:10 +0000

libsdl2 (2.29.1+dfsg-1) experimental; urgency=medium

  * New upstream development prerelease
  * d/copyright: Document license of src/video/yuv2rgb
  * d/patches: Update patch series
  * d/control, d/gbp.conf: Update branches now we have a prerelease

 -- Simon McVittie <smcv@debian.org>  Sun, 21 Jan 2024 13:12:13 +0000

libsdl2 (2.29~git20240113~38d11e5c+dfsg-1) experimental; urgency=medium

  * New upstream snapshot release-2.28.0-385-g38d11e5cc
  * Drop most patches, applied upstream
  * Move non-upstreamable patches into d/p/debian/

 -- Simon McVittie <smcv@debian.org>  Mon, 15 Jan 2024 18:12:37 +0000

libsdl2 (2.29~git20240109~2afd04d0+dfsg-2) experimental; urgency=medium

  * d/p/Use-the-X11-driver-if-the-application-uses-X11-based-grap.patch,
    d/p/Only-force-X11-if-SDL_VIDEO_DRIVER_X11-is-available.patch:
    Add patches from upstream git to avoid native Wayland in games that use
    GLEW, NVIDIA Cg or plib. This brings us up to the equivalent of
    upstream commit release-2.28.0-373-g970ed36de.
  * d/p/test-Use-AUDIO_F32SYS-for-native-endianness.patch,
    d/p/test-Fix-encoding-declaration-for-RGB24-test-images.patch,
    d/p/test-Use-SDL_CreateRGBSurfaceWithFormatFrom-for-SDLTest_I.patch:
    Add proposed patches to fix automated test failures on big-endian,
    which caused FTBFS on architectures like s390x, powerpc and ppc64
  * d/sdl2-config.1: Recommend using pkgconf instead
  * d/sdl2-config.1: Describe preferred ways to detect SDL in common build
    systems

 -- Simon McVittie <smcv@debian.org>  Wed, 10 Jan 2024 12:21:26 +0000

libsdl2 (2.29~git20240109~2afd04d0+dfsg-1) experimental; urgency=medium

  * New upstream snapshot release-2.28.0-371-g2afd04d09
  * d/copyright: Update
  * d/gbp.conf: Don't always sign upstream tags
  * d/rules: Run upstream testautomation program as a unit test.
    This was historically not run as an acceptance test, but we now have
    it passing tests upstream, at least with the dummy audio and video
    drivers that are used during build.
  * d/rules: Run testautomation as an "as-installed" test.
    As with the build-time tests, this was not historically run as a
    test, but SDL3 and sdl2-compat both do that, and we now have the
    vast majority of it working in SDL2 as well.

 -- Simon McVittie <smcv@debian.org>  Tue, 09 Jan 2024 15:19:21 +0000

libsdl2 (2.29~git20240103~7b4f1ef0+dfsg-1) experimental; urgency=medium

  * New upstream snapshot
  * d/copyright: Update
  * Refresh patch series, dropping patches that are in the upstream snapshot
  * d/libsdl2-2.0-0.symbols: Update

 -- Simon McVittie <smcv@debian.org>  Wed, 03 Jan 2024 20:10:40 +0000

=== debian/control ===
Source: libsdl2
Priority: optional
Section: libs
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian SDL packages maintainers <pkg-sdl-maintainers@lists.alioth.debian.org>
Uploaders:
 Manuel A. Fernandez Montecelo <mafm@debian.org>,
 Felix Geyer <fgeyer@debian.org>,
 Simon McVittie <smcv@debian.org>
Standards-Version: 4.6.2
Build-Depends:
 debhelper-compat (= 13),
 fcitx-libs-dev,
 libasound2-dev [linux-any],
 libdbus-1-dev,
 libdecor-0-dev (>= 0.1.1-2~) [linux-any],
 libdrm-dev [linux-any],
 libegl-dev [!hurd-any],
 libgbm-dev [linux-any],
 libgl-dev,
 libgles-dev [!hurd-any],
 libibus-1.0-dev,
 libpipewire-0.3-dev (>= 0.3.20) [linux-any],
 libpulse-dev,
 libsamplerate0-dev,
 libsndio-dev,
 libudev-dev [linux-any],
 libusb2-dev [kfreebsd-any],
 libusbhid-dev [kfreebsd-any],
 libvulkan-dev [linux-any],
 libwayland-dev (>= 1.18) [linux-any],
 libx11-dev,
 libxcursor-dev,
 libxext-dev,
 libxfixes-dev,
 libxi-dev,
 libxinerama-dev,
 libxkbcommon-dev (>= 0.5.0),
 libxrandr-dev,
 libxss-dev,
 libxt-dev,
 libxv-dev,
 libxxf86vm-dev,
 pkg-config,
 wayland-protocols
Build-Depends-Indep:
 graphviz <!nodoc>,
 doxygen <!nodoc>,
Vcs-Git: https://salsa.debian.org/sdl-team/libsdl2.git
Vcs-Browser: https://salsa.debian.org/sdl-team/libsdl2
Homepage: https://www.libsdl.org/
Rules-Requires-Root: no

Package: libsdl2-2.0-0
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends}
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Suggests:
 xdg-utils,
Conflicts:
 libsdl-1.3-0
Replaces:
 libsdl-1.3-0
Description: Simple DirectMedia Layer
 SDL is a library that allows programs portable low level access to a video
 framebuffer, audio output, mouse, and keyboard.
 .
 This version of SDL is compiled with X11 and Wayland graphics drivers and OSS,
 ALSA, sndio and PulseAudio sound drivers.

Package: libsdl2-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libasound2-dev [linux-any],
 libdbus-1-dev,
 libdecor-0-dev [linux-any],
 libdrm-dev [linux-any],
 libegl-dev [!hurd-any],
 libgbm-dev [linux-any],
 libgl-dev,
 libgles-dev [!hurd-any],
 libibus-1.0-dev,
 libpulse-dev,
 libsamplerate0-dev,
 libsdl2-2.0-0 (= ${binary:Version}),
 libsndio-dev,
 libudev-dev [linux-any],
 libusb2-dev [kfreebsd-any],
 libusbhid-dev [kfreebsd-any],
 libwayland-dev [linux-any],
 libx11-dev,
 libxcursor-dev,
 libxext-dev,
 libxfixes-dev,
 libxi-dev,
 libxinerama-dev,
 libxkbcommon-dev,
 libxrandr-dev,
 libxss-dev,
 libxt-dev,
 libxv-dev,
 libxxf86vm-dev,
 ${misc:Depends},
 ${shlibs:Depends}
Conflicts:
 libsdl-1.3-dev
Replaces:
 libsdl-1.3-dev
Description: Simple DirectMedia Layer development files
 SDL is a library that allows programs portable low level access to a video
 framebuffer, audio output, mouse, and keyboard.
 .
 This package contains the files needed to compile and link programs which
 use SDL.

Package: libsdl2-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Build-Profiles: <!nodoc>
Depends:
 ${misc:Depends},
Breaks:
 libsdl2-dev (<< 2.0.4+dfsg-1)
Replaces:
 libsdl2-dev (<< 2.0.4+dfsg-1)
Description: Reference manual for libsdl2
 SDL is a library that allows programs portable low level access to a video
 framebuffer, audio output, mouse, and keyboard.
 .
 This package contains the reference manual and examples.

Package: libsdl2-tests
Section: misc
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Suggests:
 gnome-desktop-testing
Breaks:
 libsdl2-dev (<< 2.0.22+dfsg-2~)
Replaces:
 libsdl2-dev (<< 2.0.22+dfsg-2~)
Description: Simple DirectMedia Layer automated and manual tests
 SDL is a library that allows programs portable low level access to a video
 framebuffer, audio output, mouse, and keyboard.
 .
 This package contains manual and automated tests. The automated tests can
 be run using ginsttest-runner in the gnome-desktop-testing package,
 or manually.

=== debian/tests/control ===
Tests: build
Depends: build-essential, clang:native, libsdl2-dev
Restrictions: allow-stderr, superficial

Tests: deprecated-use
Depends: build-essential, clang:native, libsdl2-dev, libsdl2-ttf-dev
Restrictions: allow-stderr, superficial

Tests: cmake
Depends: build-essential, cmake, libsdl2-dev
Restrictions: allow-stderr, superficial

Tests: installed-tests
Depends: gnome-desktop-testing, libsdl2-tests
Restrictions: allow-stderr

## libsdl2 2.30.4+dfsg

=== debian/changelog ===
libsdl2 (2.30.4+dfsg-1) unstable; urgency=medium

  * New upstream stable release
    - Pass through the original name of the Steam Virtual Gamepad, fixing
      a regression for XInput slot mapping in Proton
      (ValveSoftware/steam-for-linux#9571, steamrt/tasks#469)
    - Try to use a platform HIDAPI backend in preference to libusb
    - Add mappings for Qanba Drone 2 Arcade Joystick
    - Treat some steering wheel controllers as such:
      + VRS DirectForce Pro Wheel Base
      + Simucube 1 Wheelbase
      + Simucube 2 Ultimate Wheelbase
      + Simucube 2 Pro Wheelbase
      + Simucube 2 Sport Wheelbase
      + Cammus C5 Wheelbase
    - Don't treat Logitech HID devices as Playstation-compatible unless
      included in an allowlist, avoiding various issues with
      non-game-related Logitech HID devices
    - Treat Logitech Chillstream as a PS3 controller
    - Add support for Saitek Cyborg V.3 Rumble Pad in PS3 mode
    - Fix mapping for R1 on third party PS3 controllers
    - Treat Razer Kitsune arcade stick as a PS5 controller, and work around
      lack of support for the feature-detection protocol
    - Improve handling of Nintendo Switch controllers
    - Don't crash if SDL_GetHint(NULL) is called
    - Avoid undefined behaviour if SDL_iconv_string needs to resize
      the buffer
    - In Wayland, set the initial min/max limits when showing a window
      without libdecor loaded
    - Various Windows-, macOS- and OS/2-specific changes not listed here
  * d/copyright: Exclude VisualC-GDK from orig tarball

 -- Simon McVittie <smcv@debian.org>  Tue, 18 Jun 2024 12:57:02 +0100

libsdl2 (2.30.3+dfsg-1) unstable; urgency=medium

  * New upstream stable release
    - Fix compilation in C89 mode
    - Treat Thrustmaster TS-XW as a steering wheel
    - Fix pointer warp on XWayland
    - Speed up input device enumeration by trying not to open irrelevant
      devices
    - Don't use -mlasx to avoid baseline violation on loong64
    - Various Windows-specific changes

 -- Simon McVittie <smcv@debian.org>  Wed, 29 May 2024 16:48:47 +0100

libsdl2 (2.30.2+dfsg-1) unstable; urgency=medium

  * New upstream stable release
    - Fix a udev device enumeration performance regression
    - Don't fail joystick initialization if udev isn't available
    - Treat Sega Genesis/Mega Drive controller as having 6 buttons
    - Add gamepad mapping for Defender Joystick Cobra R4
    - Remove generic mapping for HORI product ID 0d00, which has been
      reused for several incompatible controllers
    - Treat Yawman Arrow as a flight stick
    - Don't treat MadCatz Saitek Side Panel Control Deck as
      Playstation-compatible
    - Try to use memfd_create() for Wayland cursors
    - Avoid a crash under Wayland when all displays are disconnected
    - Avoid protocol errors under Wayland if the viewport source is resized
      under fractional scaling
  * d/patches: Drop patches that were applied upstream
  * Standards-Version: 4.7.0 (no changes required)

 -- Simon McVittie <smcv@debian.org>  Tue, 16 Apr 2024 15:43:48 +0100

libsdl2 (2.30.1+dfsg-4) unstable; urgency=medium

  * d/control, d/rules: Re-enable native pipewire audio backend.
    Convert it into a pkg.libsdl2.nopipewire build-profile, so that it's
    convenient to break cycles in any future transitions that affect it.
    This is a "non-reproducible" build profile, which makes functional
    changes to the package, so breaking this cycle by building pipewire
    with noinsttest is likely to be preferable.
  * d/control, d/rules: Also add a pkg.libsdl2.nosndio build-profile
    to disable sndio audio output, similar to the one for Pipewire
  * d/control: Stop listing the audio drivers in the libsdl2-2.0-0
    Description.
    This list was out of date (Pipewire was missing), and is not
    particularly interesting information anyway. It seems to have been
    left over from early libsdl1.2 packaging, where there were multiple
    binary builds from the same source with different features enabled.

 -- Simon McVittie <smcv@debian.org>  Mon, 25 Mar 2024 11:23:34 +0000

libsdl2 (2.30.1+dfsg-3) unstable; urgency=medium

  * Temporarily disable native Pipewire output on 32-bit non-x86.
    libsdl2 is involved in a cyclic build-dependency with pipewire and
    libcamera. This change can be reverted after it has been rebuilt.

 -- Simon McVittie <smcv@debian.org>  Fri, 22 Mar 2024 11:05:04 +0000

libsdl2 (2.30.1+dfsg-2) unstable; urgency=medium

  * d/control, d/tests: Prefer pkgconf over pkg-config
  * d/p/Fixed-crash-if-joystick-functions-are-passed-a-NULL-joyst.patch:
    Add proposed patch to fix crash during doomsday startup
    (Closes: #1062969)

 -- Simon McVittie <smcv@debian.org>  Sat, 09 Mar 2024 11:49:07 +0000

libsdl2 (2.30.1+dfsg-1) unstable; urgency=medium

  * New upstream stable release
    - Fix conversion of signed 16-bit audio to floating point 32-bit
    - Improve gamepad mapping for Sanwa Supply JY-P76USV (also known as
      GameShark GS-GP702)
    - Treat OpenFFBoard as a steering wheel
    - Fix a memory leak in Steam virtual gamepad handling
    - Fix memory leaks in Wayland keyboard map handling
    - Update viewport clipping rectangle when required
    - Use CSS/freedesktop.org cursor names with traditional X11 names as
      a fallback, fixing use of non-default cursors with updated
      adwaita-icon-theme
    - Convert mouse wheel coordinates to renderer view
    - Fix a regression in 2.30.0 for the Vanilla-Conquer game engine
    - Improve robustness of unit test for mathematical functions
  * d/patches: Add post-release fixes from upstream release-2.30.x branch,
    up to commit release-2.30.1-3-g3f0d7a293, excluding a Windows-specific
    change
    - d/p/SDL_RWFromFile-stdio-allow-named-pipes-along-with-regular.patch:
      Allow opening fifos with SDL's I/O abstraction
    - d/p/Fixed-mapping-for-the-Sanwa-Supply-JY-P76USV-controller.patch:
      Improve gamepad mapping for Sanwa Supply JY-P76USV, again


## libsdl2 2.30.6+dfsg

=== debian/changelog ===
libsdl2 (2.30.6+dfsg-1) unstable; urgency=medium

  * New upstream stable release
    - Add gamepad mapping for SplitFish Game Controller
    - Fix a crash if joystick rumble starts immediately before the
      joystick is disconnected
    - On Wayland, get a cursor successfully even if no window is focused
    - Implement SDL_COMPILE_TIME_ASSERT with C23 static_assert in
      preference to C11 _Static_assert if compiling in C23 mode
    - CMake fixes, not relevant to how we compile SDL 2 in Debian
    - Windows-, macOS- and OS/2 specific fixes, not relevant to Debian
  * d/patches: Drop patches that were included in 2.30.6

 -- Simon McVittie <smcv@debian.org>  Fri, 02 Aug 2024 11:43:06 +0100

libsdl2 (2.30.5+dfsg-1) unstable; urgency=medium

  * New upstream stable release
    - Treat ROG RAIKIRI as an Xbox Series-compatible gamepad
    - Respect SDL_RENDER_DRIVER, SDL_FRAMEBUFFER_ACCELERATION hints when
      creating an accelerated window surface
    - Add SDL_MOUSE_RELATIVE_CURSOR_VISIBLE hint allowing the hardware
      cursor to be kept visible in relative mode
    - In the KMSDRM driver, use GBM modifiers if necessary
    - Various platform-specific changes not relevant to Debian
  * d/patches: Apply post-release bug fixes up to
    release-2.30.5-18-ge7a47e783, excluding platform-specific changes not
    relevant to Debian
    - Try to create an accelerated renderer for the window surface, even
      if SDL_HINT_RENDER_DRIVER is "software"
    - Improve latency of Steam Deck controller via HIDAPI
    - Improve detection of Nintendo Switch Pro controller report mode
    - Fix attribute list for SDL_GL_FLOATBUFFERS
    - Fix unsupported KMSDRM modifiers
    - Fix a race condition in multi-threaded applications
    - Fix an off-by-one that led to rare sem_timedwait() failures
    - Ensure that all functions have proper prototypes

 -- Simon McVittie <smcv@debian.org>  Fri, 19 Jul 2024 11:23:48 +0100

## libsdl2 2.30.9+dfsg

=== debian/changelog ===
libsdl2 (2.30.9+dfsg-1) unstable; urgency=medium

  * New upstream stable release
    - Only use Steam virtual gamepad if actually running from Steam
      (which sets a hint telling us to use it)
    - Reduce size of blitting code
    - Fix build issues for dependent code if it uses vulkan.hpp
    - When using X11, set the correct clipboard target type
    - When using native Wayland, always create a viewport if available,
      fixing display issues under GNOME
    - When using native Wayland, don't initialize OpenGL if not requested,
      which can cause protocol violations now that the explicit sync
      protocol is in use
    - In testdrawchessboard, make it easier to switch to the accelerated
      render API for comparison
    - 3DS-, Android-, emscripten-, macOS-, Vita- and Windows-specific
      fixes not relevant to Debian
  * d/p/Reapply-wayland-Don-t-initialize-OpenGL-when-the-window-f.patch:
    Drop patch, applied upstream

 -- Simon McVittie <smcv@debian.org>  Mon, 04 Nov 2024 17:12:21 +0000

libsdl2 (2.30.8+dfsg-1) unstable; urgency=medium

  * New upstream stable release
    - Use a better stack size for PulseAudio hotplugging
    - Fix a hang if PulseAudio hotplugging fails to initialize
    - Treat Thrustmaster TMX as a steering wheel
    - Avoid sending excessive packets to PS4, PS5 controllers when
      using raw HID
    - Don't use incorrect optimized blit for SDL_PIXELFORMAT_ARGB1555
    - Add double-buffering support to Wayland video backend
    - Use correct SONAME when dynamically loading libX11-xcb.so.1
      for use with Vulkan
    - Send SDL_WINDOWEVENT_EXPOSED for Wayland windows when required
    - Fix memory leaks in Vulkan video driver
    - Add fallbacks so KMSDRM can work with older libdrm and libgbm
    - Keep KMSDRM fd open after drmDropMaster() if possible
    - Fix thread-safety and memory leaks in unit tests
    - Android- and Windows-specific fixes not relevant to Debian
  * d/p/Reapply-wayland-Don-t-initialize-OpenGL-when-the-window-f.patch:
    Add a post-release bugfix from upstream

 -- Simon McVittie <smcv@debian.org>  Fri, 04 Oct 2024 17:12:21 +0100

libsdl2 (2.30.7+dfsg-1) unstable; urgency=medium

  * New upstream stable release
    - Fix XWayland cursor becoming visible when using relative mouse capture
    - Fix a crash when the current mouse capture window is destroyed
    - Treat Cammus C12 Wheelbase as a steering wheel
    - Add support for PS3 controller clones that do not have
      pressure-sensitive buttons, such as Retro-Bit Controller
    - Fix KMSDRM initialization failure on some Linux systems
    - Implement left-justification in SDL_snprintf on all platforms
    - Android-, Vita- and Windows-specific fixes not relevant to Debian

 -- Simon McVittie <smcv@debian.org>  Mon, 02 Sep 2024 13:53:14 +0100

## libsdl2 2.30.10+dfsg

=== debian/changelog ===
libsdl2 (2.30.10+dfsg-1) unstable; urgency=medium

  * New upstream stable release
    - Support multiple joystick buttons outputting the same gamepad button
    - Improve portability of printing 64-bit integers
    - Improve the performance of whole-surface fill operations if there
      is no padding between rows
    - Fix order of events in case audio buffer size changes
    - Improve reproducibility of dynapi build
    - Fix a buffer overflow that caused a rare crash on KMSDRM
    - Disable AMD 3dNow extensions by default, avoiding miscompilation on
      some x86 CPUs when using -march=native -mtune=native
    - Android-, macOS-, Vita- and Windows-specific fixes not relevant
      to Debian
  * d/salsa-ci.yml: Use recommended recipe

 -- Simon McVittie <smcv@debian.org>  Mon, 09 Dec 2024 11:23:13 +0000

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,12 @@
 Source: libsdl2
 Priority: optional
 Section: libs
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian SDL packages maintainers <pkg-sdl-maintainers@lists.alioth.debian.org>
+Maintainer: Debian SDL packages maintainers <pkg-sdl-maintainers@lists.alioth.debian.org>
 Uploaders:
  Manuel A. Fernandez Montecelo <mafm@debian.org>,
  Felix Geyer <fgeyer@debian.org>,
  Simon McVittie <smcv@debian.org>
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Build-Depends:
  debhelper-compat (= 13),
  fcitx-libs-dev,
@@ -20,10 +19,10 @@
  libgl-dev,
  libgles-dev [!hurd-any],
  libibus-1.0-dev,
- libpipewire-0.3-dev (>= 0.3.20) [linux-any],
+ libpipewire-0.3-dev (>= 0.3.20) <!pkg.libsdl2.nopipewire>,
  libpulse-dev,
  libsamplerate0-dev,
- libsndio-dev,
+ libsndio-dev <!pkg.libsdl2.nosndio>,
  libudev-dev [linux-any],
  libusb2-dev [kfreebsd-any],
  libusbhid-dev [kfreebsd-any],
@@ -41,7 +40,7 @@
  libxt-dev,
  libxv-dev,
  libxxf86vm-dev,
- pkg-config,
+ pkgconf,
  wayland-protocols
 Build-Depends-Indep:
  graphviz <!nodoc>,
@@ -69,8 +68,7 @@
  SDL is a library that allows programs portable low level access to a video
  framebuffer, audio output, mouse, and keyboard.
  .
- This version of SDL is compiled with X11 and Wayland graphics drivers and OSS,
- ALSA, sndio and PulseAudio sound drivers.
+ This package contains the shared library.
 
 Package: libsdl2-dev
 Section: libdevel
@@ -89,7 +87,7 @@
  libpulse-dev,
  libsamplerate0-dev,
  libsdl2-2.0-0 (= ${binary:Version}),
- libsndio-dev,
+ libsndio-dev <!pkg.libsdl2.nosndio>,
  libudev-dev [linux-any],
  libusb2-dev [kfreebsd-any],
  libusbhid-dev [kfreebsd-any],
